/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.Vector;
import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;
import javax.sound.sampled.Clip;
import javax.swing.JPanel;

/**
 * Clase que dibuja la aventura e implementa todos los metodos necesarios.
 * @author Miguel Angel Pescador Santirso
 */
public class Aventura extends JPanel {
int parametros=0;
boolean fijarverbo;
int pasosverbo=0;
int cursorx;
int cursory;
Vector verbos;
Vector room;
Verbo verboActual;
Verbo verbodefecto;
Vector globales;
Vector locales;
Cuarto habitacionActual;
Image buffer;
Graphics bb;
Font fuente;
Sistema sis;
boolean sonido=false;
Sequence sequence;
Sequencer sequencer= null;
/**
 * Constructor básico de la Aventura
 */
public Aventura(){
 
}
/**
 * Constructor real de la aventura.
 * @param sistema Valores del Sistema de aventura.
 * @param habitaciones Cuartos que contendra la aventura.
 * @param accionesglobales Acciones que se aplican a todas las habitaciones.
 */
public Aventura(Sistema sistema, Vector habitaciones, Vector accionesglobales){
     fijarParametros(sistema,habitaciones,accionesglobales);
    //buffer=this.createImage(width, height);
    //bb=buffer.getGraphics();
   
    
    //buffer = createImage(size().width, size().height);

}
/**
 * Fija los parametros del Panel de Aventura.
 * @param sistema Clase Sistema con las preferencias del sistema.
 * @param habitaciones Vector de habitaciones.
 * @param accionesglobales Vector de acciones globales.
 */
public void fijarParametros(Sistema sistema, Vector habitaciones, Vector accionesglobales){
    parametros=1;
    verbos=sistema.getVerbos();
    room=habitaciones;
    globales=accionesglobales;
    fuente=sistema.fuente;
    sis=sistema;
    if(sis.cursor!=null){
    Toolkit toolkit=this.getToolkit();
    this.setCursor(toolkit.createCustomCursor(sis.cursor.getImage(),sis.puntocursor,""));
    }
    for (int i=0;i<verbos.size();i++){
        if((((Verbo)verbos.get(i)).nombre).equals(sistema.verbodefecto)){
            verbodefecto=(Verbo)verbos.get(i);
    }
    }
    this.addMouseListener(new GestorRaton(this));
    this.addMouseMotionListener(new GestorRaton(this));
}
/**
 * Redibuja la pantalla de aventura
 */
    @SuppressWarnings("static-access")
public void redibujar(){       
         this.setDoubleBuffered(true);
         this.setOpaque(true);
    //pintarSistema(g);
        if (parametros==0){
            Image img = Toolkit.getDefaultToolkit().getImage("images\\se.jpg");
            bb.drawImage(img, 0, 0, this);
        }else{
            //-->Seleccion de Habitacion NEXT
            for(int i=0;i<room.size();i++){
                if(((Cuarto)room.elementAt(i)).nombre.equals(sis.habitacionInicial)){
                    habitacionActual=(Cuarto)room.elementAt(i);
                }
            }
           
            try {
            if (sonido==false && !habitacionActual.sonidofondo.equals("")){
            sonido=true;
            sequence = MidiSystem.getSequence(new File(habitacionActual.sonidofondo));
            System.out.println("Reproduciendo secuencia midi:"+habitacionActual.sonidofondo);
            // Create a sequencer for the sequence
            sequencer = MidiSystem.getSequencer();
            sequencer.open();
            sequencer.setSequence(sequence);
            // Start playing
            sequencer.start();
            }else if(sonido==true && habitacionActual.sonidofondo.equals("")){
                sequencer.stop();
                sonido=false;
            }
        } catch (MalformedURLException e) { } catch (IOException e) { } catch (MidiUnavailableException e) { } catch (InvalidMidiDataException e) { }
        
            locales=(habitacionActual.acciones);
            //pintarSistema();
            pintarHabitacion(habitacionActual);
            if(habitacionActual.nombre.indexOf("intro")==-1){
                pintarSistema();
                if(sis.paneldeconversacion==false){
                    pintarInventario(sis.personajeelemento, bb);
                }else{
                    pintarPaneldeConversacion();
                }
            }
            

        }
}
/*public void paint(Graphics g){
    update( g );
}*/
/**
 * Pinta los componentes de la aventura
 * @param g Graphics, cursor de dibujo de la aventura.
 */
    @Override
protected void paintComponent(Graphics g) {
    //super.paintComponent (g);
        buffer= createImage(getSize().width,getSize().height);
        bb = buffer.getGraphics();
        update( g );

 }
 /**
 * Actualiza los componentes de la aventura
 * @param g Graphics, cursor de dibujo de la aventura.
 */
   @Override
  public void update(Graphics g){
    redibujar();
    g.drawImage( buffer, 0, 0, this );

      //g.clipRect(0,0,sis.PANTALLAHORIZONTAL,320);
  //paintComponent(g);
}
   
/**
 * Dibuja el sistema SCUMM.
 */
public void pintarSistema(){
    Graphics2D g=(Graphics2D)bb;
    g.setFont(fuente);
    g.setColor(Color.BLACK);
    //g.fill3DRect(0, 0, sis.PANTALLAHORIZONTAL, ((int)(sis.PANTALLAVERTICAL*0.62)), false);
    g.setColor(Color.BLUE);
    //Cuadriculas Verbos y rellenar verbos.
    int k=0;
    
    for(int i=0;i<180;i=i+88){
        for(int j=(int)(sis.PANTALLAVERTICAL*0.66);j<430;j=j+54){
            g.fill3DRect(i, j, 87, 53, false);
            if(((Verbo)verbos.elementAt(k)).getImagen()!=null){
                g.drawImage(((Verbo)verbos.elementAt(k)).getImagen(), i, j, this);

            }else{
                g.drawString(((Verbo)verbos.elementAt(k)).getEtiqueta(),i+10, j+20);
        }
            k++;
        }
    }
    
    //Subir bajar Elementos
    if(sis.inventario.imagenes.isEmpty()){
        g.setColor(sis.inventario.getPapel());
        g.fill3DRect(261, 320, 30, 82,false);
        g.fill3DRect(261, 402, 30, 82,false);
        g.setColor(sis.inventario.getTinta() );
        g.drawString("▲",270, 372);
        g.drawString("▼",270, 452);
        g.setColor(sis.inventario.getPapel());
    }else{
        int desplazamientox=(int)((sis.PANTALLAHORIZONTAL*0.55)/(sis.inventario.TAMANO/2));
        int desplazamientoy=(int) ((sis.PANTALLAVERTICAL*0.33)/2);
        g.drawImage(sis.inventario.getImagen(0),(int)(sis.PANTALLAHORIZONTAL*0.41),(int)(sis.PANTALLAVERTICAL*0.66), this);
        g.drawImage(sis.inventario.getImagen(2),(int)(sis.PANTALLAHORIZONTAL*0.41),(int)(sis.PANTALLAVERTICAL*0.66)+desplazamientoy, this);
    }
    //Filas de Elementos
    
    g.setColor(sis.inventario.getPapel() );
    //zona de estado
    g.fill3DRect(0, ((int)(sis.PANTALLAVERTICAL*0.62)), sis.PANTALLAHORIZONTAL, 20,false);
    g.setColor(sis.inventario.getTinta() );
   
}
/**
 * Dibuja de habitacion actual.
 * @param cuarto Cuarto habitacion actual.
 */
public void pintarHabitacion(Cuarto cuarto){
    Graphics2D h= (Graphics2D)bb;
    if(cuarto.getFondo()!=null){
        int alto=cuarto.getFondo().getImage().getHeight(this);
        int ancho=cuarto.getFondo().getImage().getWidth(this);
        if(habitacionActual.nombre.indexOf("intro")==-1){
            if(alto>(sis.PANTALLAVERTICAL*0.66)){
                alto=alto-((int)(sis.PANTALLAVERTICAL*0.66));
            }else{alto=0;}
            if(ancho>sis.PANTALLAHORIZONTAL){
                ancho=0;//ancho-sis.PANTALLAHORIZONTAL;
            }else{ancho=0;}

            /*if(sis.personajeelemento.posicion[0]>(sis.PANTALLAHORIZONTAL/2)){
                ancho++;}
            */}else{
                ancho=0;
                alto=0;
            }
        h.drawImage(cuarto.getFondo().getImage(), -ancho, -alto, this);

        }
    else{
        h.setColor(Color.BLACK);
        h.fill3DRect(0, 0, sis.PANTALLAHORIZONTAL, ((int)(sis.PANTALLAVERTICAL*0.66)),false);

    }
    for(int i=0;i<cuarto.elementos.size();i++){
                Elemento a=(Elemento)cuarto.elementos.elementAt(i);
                if(a.nombre.equals(sis.personaje)){
                    sis.personajeelemento=a;
                }
            }
    Vector elem=cuarto.elementos;
    for(int i=0;i<elem.size();i++){
        Elemento a=(Elemento)elem.elementAt(i);
        int[] b=a.getPosicion();
        if(b[2]!=0){
            Image escala=a.getImagen();
            double esc=((double)b[2])/100;

            int escalaAncho = (int)( esc*a.getImagen().getWidth(this) );
            int escalaAlto = (int)( esc*a.getImagen().getHeight(this) );
            BufferedImage imgFinal = new BufferedImage(escalaAncho,escalaAlto,BufferedImage.TYPE_4BYTE_ABGR_PRE );
            AffineTransform tranformador = new AffineTransform();
            tranformador.scale(esc,esc);
            Graphics2D g2 = imgFinal.createGraphics();
            g2.drawImage( escala ,tranformador,this );
            g2.dispose();
            h.drawImage( imgFinal,b[0],b[1]-escalaAlto,this);
            a.setPosicion(b[0],b[1],b[2]);
        }else{
            h.drawImage(a.getImagen(),b[0],b[1]-a.getImagen().getHeight(this),this);
        }
    }

    }
/**
 * Dibuja el inventario del personaje actual.
 * @param invelem Elemento Personaje actual.
 * @param hh Graphics, cursos de dibujo.
 */
    public void pintarInventario(Elemento invelem,Graphics hh){
        Vector inventario=new Vector();
        try{
            //Si esta vacio lanza una excepcion.
            inventario=sis.personajeelemento.getElementos();
        }catch(ArrayIndexOutOfBoundsException e){}
        hh.setColor(sis.inventario.getPapel());
        int desplazamientox=(int)((sis.PANTALLAHORIZONTAL*0.55)/(sis.inventario.TAMANO/2));
        int desplazamientoy=(int) ((sis.PANTALLAVERTICAL*0.33)/2);
        if(inventario.isEmpty()){
            for (int i=(int)(sis.PANTALLAHORIZONTAL*0.45);i<(sis.PANTALLAHORIZONTAL-desplazamientox+1);i=i+desplazamientox){
                for(int j=((int)(sis.PANTALLAVERTICAL*0.66));j<(sis.PANTALLAVERTICAL-desplazamientoy+1);j=j+desplazamientoy){
                    hh.fill3DRect(i, j, desplazamientox, desplazamientoy,false);
                }
            }
        }else{
            int k=0;
            int l=inventario.size();
            for (int i=(int)(sis.PANTALLAHORIZONTAL*0.45);i<(sis.PANTALLAHORIZONTAL-desplazamientox+1);i=i+desplazamientox){
                for(int j=(int)(sis.PANTALLAVERTICAL*0.66);j<405;j=j+desplazamientoy){
                    if(k<l && k<sis.inventario.TAMANO){
                        hh.drawImage(((Elemento)inventario.get(k)).getIcono(),i,j,this);
                    }else{
                    hh.fill3DRect(i, j, desplazamientox, desplazamientoy,false);
                    }
                    k++;
                    }
            }

    }}
    /**
    * Dibuja el panel de conversación.
    */
    public void pintarPaneldeConversacion(){
        Graphics2D g=(Graphics2D)bb;
     if(sis.inventario.imagenes.isEmpty()){
        g.setColor(sis.inventario.getPapel());
        g.fill3DRect(0, (int)(sis.PANTALLAVERTICAL*0.66), 30, 82,false);
        g.fill3DRect(0, 402, 30, 82,false);
        g.setColor(sis.inventario.getTinta() );
        g.drawString("▲",270, 372);
        g.drawString("▼",270, 452);
        g.setColor(sis.inventario.getPapel());
    }else{
        g.drawImage(sis.inventario.getImagen(0),0,(int)(sis.PANTALLAVERTICAL*0.66), this);
        g.drawImage(sis.inventario.getImagen(2),0,(int)(sis.PANTALLAVERTICAL*0.66)+sis.inventario.getImagen(2).getHeight(this), this);
    }
        int k=(int)((sis.PANTALLAVERTICAL*0.33)/sis.panelconversacion.TAMANO);
        int d=0;
        String texto=new String("_");
        for(int j=((int)(sis.PANTALLAVERTICAL*0.66));j<sis.PANTALLAVERTICAL-k+1;j=j+k){
            g.setColor((sis.inventario.getPapel()));
            g.fill3DRect(sis.inventario.getImagen(0).getWidth(this), j, sis.PANTALLAHORIZONTAL-sis.inventario.getImagen(0).getWidth(this), k,false);
            System.out.println("Tamaño vector opciones"+sis.panelconversacion.opciones.size());
            g.setColor(sis.inventario.getTinta());
            if(sis.panelconversacion.opciones.get(d).toString()!=null)
                texto=sis.panelconversacion.opciones.get(d).toString();
                g.drawString(texto, 60, j+k-((int)k/2));
                d++;
            
        }

    }

    /**
     * Devuelve el cursor del Buffer externo de dibujo.
     * @return Graphics cursor del Doble Buffer.
     */
    public Graphics getDobleBuffer(){
        return bb;
    }
}
