/* LSAGPI                                      */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JWindow;


/**
 * Clase principal del motor
 * @author Miguel Angel Pescador Santirso
 */
public class LSAGPI extends JFrame{

	BarraDeMenus barrademenus=new BarraDeMenus();
    Aventura panel;
    static int parametros=0;
    JFileChooser fc = new JFileChooser();
	FiltroADV filtroadv = new FiltroADV();
    javax.swing.filechooser.FileFilter defaultFileFilter;
    /**
     * Contructor del motor.
     */
public LSAGPI(){

		addWindowListener(new WindowAdapter(){
            @Override
			public void windowClosing(WindowEvent e){
				System.exit(0);
				}});
        filtroadv.addExtension("adv");
		filtroadv.setDescripcion("Archivos de Aventura");
        defaultFileFilter = fc.getFileFilter();
		fc.setFileFilter(filtroadv);

        if(parametros!=0){
            panel=new Aventura(sistem, habitaciones, accionesglobales);
        }else{
                    panel=new Aventura();
        }
        /*barrademenus.nuepro.addActionListener(pl.limpiar());
		barrademenus.abrirpro.addActionListener(pl.anadirArchivo());
		barrademenus.guardarpro.addActionListener(new GuardarArchivo());*/
		barrademenus.imporscript.addActionListener(new ImportarScript());
		barrademenus.salir.addActionListener(new Salir());
        barrademenus.indice.addActionListener(new LlamaIndice());
		barrademenus.acerca.addActionListener(new Acerca());
   		barrademenus.pantallacompleta.addActionListener(new PantallaCompleta());


        getContentPane().setLayout(new BorderLayout());
		getContentPane().add("North",barrademenus.getMenuBar());
		getContentPane().add("Center",panel);
}
    static Vector habitaciones=new Vector();
    static Vector accionesglobales=new Vector();
    static Sistema sistem;
    static Vector procedimientos=new Vector();

    /**
     * Metodo principal del motor.
     * @param args Argumentos en linea de comandos.
     */
    public static void main(String[] args) {
        // Recibe argumentos Fichero de Entrada y Fichero de salida.
        if ((args.length==0)){
            LSAGPI x=new LSAGPI();
			x.setSize(640,480);
			x.setTitle("LSAGPI 0.0.4");
            x.setVisible(true);
        }
        if (args.length==1){
            parametros=1;
            File archivoentrada=new File(args[0]);
            Preprocesador prepro=new Preprocesador(LSAGPI.LeerEntrada(archivoentrada));
            LSAGPI.AnalizarEntrada(prepro.getRetorno());
            LSAGPI x=new LSAGPI();
			x.setSize(sistem.PANTALLAHORIZONTAL,sistem.PANTALLAVERTICAL);
			x.setTitle(sistem.titulo);
            x.setVisible(true);
        }
        if (args.length>1){
            parametros=args.length;
            String salida=null;
            for (int i=0;i<parametros;i++){
                File archivoentrada=new File(args[i]);
                salida+=LSAGPI.LeerEntrada(archivoentrada)+"\n";
            }
            Preprocesador prepro=new Preprocesador(salida);
            LSAGPI.AnalizarEntrada(prepro.getRetorno());
            LSAGPI x=new LSAGPI();
			x.setSize(sistem.PANTALLAHORIZONTAL,sistem.PANTALLAVERTICAL);
			x.setTitle(sistem.titulo);
            x.setVisible(true);


        }

    }
    public void setTamano(int x, int y){
        this.setSize(x,y);
    }
    /**
     * Lee el archivo de entrada.
     * @param archivoentrada Archivo a leer.
     * @return String contenido del archivo.
     */
    @SuppressWarnings("empty-statement")
    public static String LeerEntrada(File archivoentrada){
        String abs = new String();
        FileReader in = null;
        File file = archivoentrada;
        if (!file.exists())
        {
            System.out.println("LSAGPI v 0.0.4 por Miguel Angel Pescador Santirso");
            System.out.println("Uso: java LSAGPI.jar aventura1.adv ... aventuraN.adv");
            System.out.println("----Uno de los archivos de entrada no existe.----");
            System.exit(1);
        }
        else
        {
            try{
            in = new FileReader(file);
            }catch(FileNotFoundException e){
                System.out.println("LSAGPI v 0.0.4 por Miguel Angel Pescador Santirso");
                System.out.println("Uso: java LSAGPI.jar aventura1.adv ... aventuraN.adv");
                System.out.println("----Uno de los archivos de entrada no existe.----");
                System.exit(1);
            }
            char[] buffer = new char[4096];
            int len;
            try
            {
                while ((len = in.read(buffer)) != -1)
                {
                    String s = new String(buffer, 0, len);
                    abs += s;
                };
             }catch (IOException ioe) {/*Excepción vacia necesaria solo para compilación ya que el control de archivo se ha hecho anteriormente*/ }
          }
        return abs;
    }
    /**
     * Analiza la entrada parseando cada objeto.
     * @param entrada String con el contenido del fichero de entrada.
     */
    public static void AnalizarEntrada(String entrada){
        StringTokenizer stoken = new StringTokenizer(entrada,"\n",true);
        boolean sistemadefecto=true;
        while (stoken.hasMoreTokens())
		{
            String cadena=stoken.nextToken();
            if(cadena.indexOf("SISTEMA")!=-1){
                System.out.println("Valores de sistema.");
                while(cadena.indexOf("{")==-1)
                    cadena=stoken.nextToken();
                cadena=stoken.nextToken();

                String instruccion=new String("");
                int contador=0;
                instruccion+=cadena;
                while( contador!=(-1) && stoken.hasMoreTokens()){
                       String cadena_contador=stoken.nextToken();
                       instruccion+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           instruccion+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           instruccion+=cadena_contador;
                       }
                    }
                    sistem=new Sistema(instruccion);
                    //System.out.println("------------Inicio SISTEMA");
                    //System.out.println(instruccion);
                    //System.out.println("------------Fin SISTEMA");
                    sistemadefecto=false;
            }

            
            if(cadena.indexOf("CUARTO")!=-1){
                System.out.println("Un cuarto.");

                StringTokenizer nom_tok=new StringTokenizer(cadena);
                String nombre=new String("");
                if(nom_tok.nextToken().equals("CUARTO")){
                    nombre=nom_tok.nextToken();
                }
                //Implementacion de la herencia.
                //se hará clonando el objeto a heredar y añadiendo
                //las caracteristicas del nuevo.
                String superclase=null;
                if(nom_tok.hasMoreTokens()){
                        if(nom_tok.nextToken().equals("EXTIENDE"))
                            superclase=nom_tok.nextToken();
                }
                String cuarto=new String("");
                int contador=0;
                while( contador!=(-1) && stoken.hasMoreTokens()){
                       String cadena_contador=stoken.nextToken();
                       if(cadena_contador.indexOf("{")==0){
                           cadena_contador=stoken.nextToken();
                       }
                       cuarto+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           cuarto+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           cuarto+=cadena_contador;
                       }
                    }
                if(superclase==null){
                    System.out.println("ENTRA AQUI");
                    habitaciones.add(new Cuarto(cuarto, nombre));
                    System.out.println("Habitacion 0 :"+nombre+"  "+((Cuarto)habitaciones.get(0)).nombre);

                }else{
                    for(int i=0;i<habitaciones.size();i++){
                        if(((Cuarto)habitaciones.elementAt(i)).nombre.equals(superclase)){
                           Cuarto heredado=((Cuarto)habitaciones.elementAt(i)).clone();
                           heredado.parsear(cuarto, nombre);
                           habitaciones.add(heredado);
                        }
                    }
                }
            }
            if(cadena.indexOf("INSTRUCCION")!=-1){
                System.out.println("Una instruccion global");
                String instruccion=new String("");
                int contador=0;
                instruccion+=cadena;
                while( contador!=(-1) && stoken.hasMoreTokens()){
                       String cadena_contador=stoken.nextToken();
                       instruccion+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           instruccion+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           contador--;
                           instruccion+=cadena_contador;
                       }
                    }
                    accionesglobales.add(new Accion(instruccion));
           }
           if(cadena.indexOf("PROCEDIMIENTO")!=-1){
                System.out.println("Un Procedimiento");
                StringTokenizer nom_tok=new StringTokenizer(cadena);
                String nombre=new String("");
                if(nom_tok.nextToken().equals("PROCEDIMIENTO")){
                    nombre=nom_tok.nextToken();
                }
                String instruccion=new String("");
                int contador=0;
                instruccion+=cadena;
                while( contador!=(-1) && stoken.hasMoreTokens()){
                       String cadena_contador=stoken.nextToken();
                       instruccion+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           instruccion+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           contador--;
                           instruccion+=cadena_contador;
                       }
                    }
                    procedimientos.add(new Procedimiento(instruccion,nombre));
           }
           }
        if(sistemadefecto){
            String sisdefaultstring="SISTEMA\n{\n    ANDAR\n    {\n        ETIQUETA { \"Andar a\" }\n	  IMAGEN { \"gr/btn_andara.jpg\" }\n        TINTA { 0 255 255 }\n	PAPEL { 0 0 0 }\n        TECLA { \"w\" }\n    }\n    VERBO Dar\n    {\n        ETIQUETA { \"Dar\" }\n	  IMAGEN { \"gr/btn_dar.jpg\" }\n        SENTENCIA { 2 \"a\" }\n        TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n        TECLA { \"g\" }\n    }\n    VERBO Coger\n    {\n        ETIQUETA { \"Coger\" }\n	  IMAGEN { \"gr/btn_coger.jpg\" }\n        TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n	TECLA { \"p\" }\n    }\n    VERBO Usar\n    {\n        ETIQUETA { \"Usar\" }\n	  IMAGEN { \"gr/btn_usar.jpg\" }\n        SENTENCIA { * \"con\" }\n        TINTA { 165 156 132 }\n        PAPEL { 80 68 48 }\n        TECLA { \"u\" }\n        CONMUTATIVO { 1 }\n    }\n    VERBO Abrir\n    {\n        ETIQUETA { \"Abrir\" }\n	IMAGEN { \"gr/btn_abrir.jpg\" }\n        TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n	TECLA { \"o\" }\n    }\n    VERBO Hablar\n    {\n      ETIQUETA { \"Hablar a\" }\n	IMAGEN { \"gr/btn_hablara.jpg\" }\n      TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n      TECLA { \"t\" }\n    }\n    VERBO Push\n    {\n      ETIQUETA { \"Empujar\" }\n	IMAGEN { \"gr/btn_empujar.jpg\" }\n      TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n    }\n    VERBO Cerrar\n    {\n      ETIQUETA { \"Cerrar\" }\n	IMAGEN { \"gr/btn_cerrar.jpg\" }\n     TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n	TECLA { \"c\" }\n    }\n    VERBO Mirar\n    {\n        ETIQUETA { \"Mirar\" }\n	  IMAGEN { \"gr/btn_mirar.jpg\" }\n	  TINTA { 165 156 132 }\n	  PAPEL { 80 68 48 }\n        TECLA { \"l\" }\n    }\n    VERBO Pull\n    {\n      ETIQUETA { \"Tirar\" }\n	IMAGEN { \"gr/btn_tirar.jpg\" }\n      TINTA { 165 156 132 }\n	PAPEL { 80 68 48 }\n    }\n    VERBODEFECTO { Mirar }\n    FPS { 20 }\n    ANGULOS { 4 }\n    PANTALLA { 640 480 }\n   JUGADOR { chaval }\n    INVENTARIO\n    {\n        TAMAÑO { 10 }\n        TINTA { 116 100 68 }\n        PAPEL { 80 68 48 }\n        IMAGEN\n        {\n        	\"gr/inv_arriba.jpg\"    \"gr/inv_arriba_c.jpg\"\n        	\"gr/inv_abajo.jpg\"    \"gr/inv_abajo_c.jpg\"\n        }\n    }\n   TITULO { \"Aventura sin Titulo\" }\n   CURSOR { \"gr/m_cross.gif\" 15 15 }\n   HABLAR\n    {\n      TAMAÑO { 4 }\n      TINTA { 165 156 132 }\n      PAPEL { 80 68 48 }\n      FUENTE { \"SansSerif\" 11 }\n    }\nFUENTE { \"SansSerif\" 20 }\nINICIO { \"principal\" }\n}";
            sistem=new Sistema(sisdefaultstring);
        }
        }
    /**
     * Clase que genera el dialogo acerca de...
     */
class Acerca implements ActionListener{

		public void actionPerformed(ActionEvent e){
       			AboutBox a=new AboutBox(LSAGPI.this);
       			a.setSize(500,400);
       			a.setVisible(true);
 		  }
	}
/**
 * Clase que muestra el dialogo para abrir un archivo de aventura.
 */
class ImportarScript implements ActionListener{

		public void actionPerformed(ActionEvent e){
            fc.setFileFilter(filtroadv);
			fc.setMultiSelectionEnabled(false);
			fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
			int returnVal = fc.showOpenDialog(LSAGPI.this);
			if (returnVal == JFileChooser.APPROVE_OPTION)
			{
                Preprocesador prepro=new Preprocesador(LSAGPI.LeerEntrada(fc.getSelectedFile().getAbsoluteFile()));
                LSAGPI.AnalizarEntrada(prepro.getRetorno());
                setTitle(sistem.titulo);
                panel.fijarParametros(sistem, habitaciones, accionesglobales);
            }
 		  }
	}
/**
 * Clase que llama al Indice de la Ayuda.
 */
class LlamaIndice implements ActionListener
	{

		public void actionPerformed(ActionEvent e)
		{
			Indice a = new Indice(LSAGPI.this);
			a.setSize(411, 467);
			a.setVisible(true);
		}
	}
/**
 * Clase que termina la aplicacion.
 */
class Salir implements ActionListener{
		public void actionPerformed (ActionEvent e){
            //screen.restoreScreen();
			System.exit(0);
		}
	}
/**
 * Clase que pone la aplicacion en pantalla completa.
 */
class PantallaCompleta implements ActionListener{
		public void actionPerformed (ActionEvent e){
             JWindow w = new JWindow(LSAGPI.this);
                w.add(panel);
                setSize(0,0);
                w.setSize(Toolkit.getDefaultToolkit().getScreenSize());
                w.setVisible(true);
			 /* GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
            GraphicsDevice[] devices = env.getScreenDevices();
            GraphicsDevice device=null;
            DisplayMode k=null;
            for (int i=0;i<devices.length;i++){
                device=devices[i];
                k=devices[i].getDisplayMode();
                System.out.println("Alto: "+k.getHeight()+"\nAncho: "+k.getWidth()+"\nProfundidad de Color: "+k.getBitDepth()+"\nRefresco: "+k.getRefreshRate());
             }
             device.setFullScreenWindow(LSAGPI.this);

      if (k != null &&
            device.isDisplayChangeSupported())
        {
            try {
                device.setDisplayMode(k);
            }
            catch (IllegalArgumentException ex) { }
            // fix for mac os x
            setVisible(false);
            setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            setUndecorated(true);
            setIgnoreRepaint(true);
            setResizable(false);
            setTamano(k.getWidth(), k.getHeight());
            setVisible(true);
            }*/
		}
	}
}

    
