/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/

package lsagpi;

import java.util.StringTokenizer;
import java.util.Vector;

/**
 * Clase para parsear los procedimientos de Usuario.
 * @author Miguel Angel Pescador Santirso.
 */
public class Procedimiento {
    String nombre;
    String[] parametros;
    Vector<Accion> acciones=new Vector<Accion>();
 /**
 * Constructor del procedimiento
 * @param definicion Definicion del procedimiento.
 * @param nom Nombre del procedimiento.
 */
 public Procedimiento(String definicion, String nom){
        this.parsear(definicion,nom, false);
 }
 /**
 * Constructor del procedimiento
 * @param definicion Definicion del procedimiento.
 * @param nom Nombre del procedimiento.
 * @param param Array de Strings con los parametros.
 */
 public Procedimiento(String definicion, String nom, String[] param){
        parametros=param;
        this.parsear(definicion,nom, true);
 }
 /**
 * Método que parsea la definicion, util para la herencia.
 * @param definicion Definicion del cuarto.
 * @param nom Nombre del cuarto.
 */
 public void parsear(String definicion, String nom, boolean parametro ){
        nombre=nom;

        System.out.println("Una instruccion Procedimiento");
        StringTokenizer stoken = new StringTokenizer(definicion,"\n",true);
        String cadena=stoken.nextToken();
        if (parametro){
        for(int i=0;i<parametros.length;i++){
            if(cadena.indexOf(parametros[i])!=-1){
                //Reemplaza el parametro en la accion por el valor en la llamada.
                cadena.replaceAll(cadena, parametros[i]);
            }
        }
        }
        String instruccion=new String("");
        int contador=0;
        instruccion+=cadena;
        while( contador!=(-1) && stoken.hasMoreTokens()){
               String cadena_contador=stoken.nextToken();
               instruccion+=cadena_contador;
               if(cadena_contador.indexOf("{")!=-1){
                   contador++;
                   instruccion+=cadena_contador;
                }
                if(cadena_contador.indexOf("}")!=-1){
                   contador--;
                   contador--;
                   instruccion+=cadena_contador;
                }
          }
          acciones.add(new Accion(instruccion));
     }

}
