/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/


package lsagpi;

import java.awt.Font;
import java.awt.Point;
import java.io.File;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.ImageIcon;

/**
 * Clase que parsea los valores del sistema.
 * @author Miguel Angel Pescador Santirso
 */
public class Sistema {
String titulo=new String("LSGAPI v. 0.0.4");
Vector verbos=new Vector();
String verbodefecto;
int PANTALLAHORIZONTAL;
int PANTALLAVERTICAL;
Inventario inventario;
PanelConversacion panelconversacion;
int angulos;
int fps=8;
String personaje;
Elemento personajeelemento;
Font fuente;
ImageIcon cursor;
Point puntocursor;
String habitacionInicial;
boolean paneldeconversacion=false;


/**
 * Constructor de la clase.
 * @param definicion Definicion del sistema.
 */
    public Sistema(String definicion){
    StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        //nombre=st.nextToken();
        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            //System.out.println(cadena);
            if(cadena.indexOf("ANDAR")!=-1){
                System.out.println("Un verbo.");
                String nombre=new String("Andar");
                String cuarto=new String("");
                int contador=0;
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       if(cadena_contador.indexOf("{")==0){
                           cadena_contador=st.nextToken();
                       }
                       cuarto+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           cuarto+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           cuarto+=cadena_contador;
                       }
                    }
                verbos.add(new Verbo(cuarto, nombre));
                }
            if(cadena.indexOf("TITULO")!=-1){
                System.out.println("Un titulo");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("TITULO {")!=-1){
                        titulo=icon_tok.nextToken();
                    }
                }
                System.out.println(titulo);
            }
            if(cadena.indexOf("INICIO")!=-1){
                System.out.println("Habitacion de Inicio");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("INICIO {")!=-1){
                        habitacionInicial=icon_tok.nextToken();
                    }
                }
                System.out.println(habitacionInicial);
            }
            if(cadena.indexOf("VERBO ")!=-1){
                System.out.println("Un verbo.");
                StringTokenizer nom_tok=new StringTokenizer(cadena);
                String nombre=new String("");
                while(nombre.indexOf("VERBO")==-1)
                        nombre=nom_tok.nextToken();
                if(nombre.equals("VERBO")){
                       nombre=nom_tok.nextToken();
                        System.out.println(nombre);
                }
                
                String cuarto=new String("");
                int contador=0;
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       if(cadena_contador.indexOf("{")==0){
                           cadena_contador=st.nextToken();
                       }
                       cuarto+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           cuarto+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           cuarto+=cadena_contador;
                       }
                    }
                verbos.add(new Verbo(cuarto, nombre));
            }
            if(cadena.indexOf("VERBODEFECTO")!=-1){
                System.out.println("Verbo por defecto");
                StringTokenizer verb_tok=new StringTokenizer(cadena," ");
                while(verb_tok.hasMoreTokens()){
                    String token=verb_tok.nextToken();
                    while(token.indexOf("{")==-1 && verb_tok.hasMoreTokens()){
                        token=verb_tok.nextToken().trim();
                    }
                        
                    if(token.indexOf("{")!=-1 && verb_tok.hasMoreTokens()){
                        verbodefecto=verb_tok.nextToken();
                    }

                }

                System.out.println(verbodefecto);
            }
            if(cadena.indexOf("JUGADOR")!=-1){
                System.out.println("Personaje Inicial");
                StringTokenizer verb_tok=new StringTokenizer(cadena," ");
                while(verb_tok.hasMoreTokens()){
                    String token=verb_tok.nextToken();
                    while(token.indexOf("{")==-1 && verb_tok.hasMoreTokens()){
                        token=verb_tok.nextToken().trim();
                    }

                    if(token.indexOf("{")!=-1 && verb_tok.hasMoreTokens()){
                        personaje=verb_tok.nextToken();
                    }

                }

                System.out.println("Personaje: "+personaje);
            }
            if(cadena.indexOf("FUENTE")!=-1){
                System.out.println("Una fuente");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("FUENTE"));
                    if(num.equals("{")){
                        String nombre=num_tok.nextToken().trim();
                        nombre=nombre.substring(1,nombre.length()-1);
                        String tamano=num_tok.nextToken().trim();
                        int tam=Integer.parseInt(tamano);
                        fuente=new Font(nombre,Font.BOLD+Font.ITALIC,tam);
                    }

                }
            }
            if(cadena.indexOf("CURSOR")!=-1){
                System.out.println("Un cursor");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("CURSOR"));
                    if(num.equals("{")){
                        String nombre=num_tok.nextToken().trim();
                        nombre=nombre.substring(1,nombre.length()-1);
                        String tamano=num_tok.nextToken().trim();
                        int tamx=Integer.parseInt(tamano);
                        tamano=num_tok.nextToken().trim();
                        int tamy=Integer.parseInt(tamano);
                        cursor=new ImageIcon(nombre);
                        puntocursor=new Point(tamx,tamy);
                    }

                }
            }
            if(cadena.indexOf("PANTALLA")!=-1){
                System.out.println("Pantalla");
                StringTokenizer pant_tok=new StringTokenizer(cadena," ");
                while(pant_tok.hasMoreTokens()){
                    String panta=pant_tok.nextToken();
                    while(panta.indexOf("{")==-1 && pant_tok.hasMoreTokens())
                        panta=pant_tok.nextToken();
                    if(panta.indexOf("{")!=-1){
                        PANTALLAHORIZONTAL=Integer.parseInt(pant_tok.nextToken().trim());
                        PANTALLAVERTICAL=Integer.parseInt(pant_tok.nextToken().trim());
                    }

                }
                System.out.println("Pantalla: "+PANTALLAHORIZONTAL+"x"+PANTALLAVERTICAL);
            }
            if(cadena.indexOf("INVENTARIO")!=-1){
                System.out.println("Un inventario.");
                String cuarto=new String("");
                int contador=0;
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       if(cadena_contador.indexOf("{")==0){
                           cadena_contador=st.nextToken();
                       }
                       cuarto+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           cuarto+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           cuarto+=cadena_contador;
                       }
                    }
                inventario=new Inventario(cuarto);
            }
            
            if(cadena.indexOf("HABLAR")!=-1){
                System.out.println("Propiedades del panel de conversacion.");
                String cuarto=new String("");
                int contador=0;
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       if(cadena_contador.indexOf("{")==0){
                           cadena_contador=st.nextToken();
                       }
                       cuarto+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           cuarto+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           cuarto+=cadena_contador;
                       }
                    }
                panelconversacion=new PanelConversacion(cuarto);
            }
            if(cadena.indexOf("ANGULOS")!=-1){
                System.out.println("Angulos");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"{");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("ANGULOS")!=-1){
                        String color=icon_tok.nextToken();
                        angulos=Integer.parseInt(color.substring(0,color.indexOf("}")-1).trim());
                    }

                }
                System.out.println("Angulos: "+angulos);
            }
            if(cadena.indexOf("FPS")!=-1){
                System.out.println("Frames por segundo");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"{");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("FPS")!=-1){
                        String color=icon_tok.nextToken();
                        fps=Integer.parseInt(color.substring(0,color.indexOf("}")-1).trim());
                    }

                }
                System.out.println("FPS: "+angulos);
            }
        }
    }
    /**
     * Devuelve los verbos del sistema.
     * @return Vector verbos.
     */
    public Vector getVerbos(){
        return verbos;
    }
}

