/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.awt.Image;
import java.util.StringTokenizer;
import javax.swing.ImageIcon;

/**
 * Clase que parsea verbos.
 * @author Miguel Angel Pescador Santirso
 */
public class Verbo{
String nombre;
String etiqueta;
int[] tinta=new int[3];
int[] papel=new int[3];
String tecla;
int sentencia=1;
String sentenciaConector=new String("");
boolean conmutativo=false;
ImageIcon imagen=null;

    /**
     * Constructor del Verbo
     * @param definicion Definicion del verbo.
     * @param nom Nombre del verbo.
     */
    public Verbo(String definicion,String nom){
        nombre=nom;
        StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        //nombre=st.nextToken();
        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            if(cadena.indexOf("TINTA")!=-1){
                System.out.println("Una tinta");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("TINTA"));
                    if(num.equals("{")){

                        tinta[0]=Integer.parseInt(num_tok.nextToken());
                        tinta[1]=Integer.parseInt(num_tok.nextToken());
                        tinta[2]=Integer.parseInt(num_tok.nextToken());
                    }

                }
                System.out.println("Tinta :"+tinta[0]+":"+tinta[1]+":"+tinta[2]);
            }
            if(cadena.indexOf("PAPEL")!=-1){
                System.out.println("Un papel");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("PAPEL"));
                    if(num.equals("{")){

                        papel[0]=Integer.parseInt(num_tok.nextToken());
                        papel[1]=Integer.parseInt(num_tok.nextToken());
                        papel[2]=Integer.parseInt(num_tok.nextToken());
                    }

                }
                System.out.println("Papel :"+papel[0]+":"+papel[1]+":"+papel[2]);
            }
            if(cadena.indexOf("ETIQUETA")!=-1){
                System.out.println("Una etiqueta");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("ETIQUETA {")!=-1){
                        etiqueta=icon_tok.nextToken();
                    }
                }
                System.out.println(etiqueta);
            }
            if(cadena.indexOf("TECLA")!=-1){
                System.out.println("Una tecla");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("TECLA {")!=-1){
                        tecla=icon_tok.nextToken();
                    }
                }
                System.out.println(tecla);
            }
            if(cadena.indexOf("SENTENCIA")!=-1){
                System.out.println("Una sentencia");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("SENTENCIA"));
                    if(num.equals("{")){
                        String conector=num_tok.nextToken();
                        if(conector.indexOf("*")==-1){
                            sentencia=Integer.parseInt(conector);
                        }else{
                            sentencia=-1;
                        }
                        conector=num_tok.nextToken();
                        sentenciaConector=conector.substring(1,conector.length()-1);
                    }

                }
                //Por implementar.
            }
            if(cadena.indexOf("IMAGEN")!=-1){
            System.out.println("Imagen de verbo");
                while(cadena.indexOf("\"")==-1){
                    cadena=st.nextToken();
                }
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                if(cadena.indexOf("{")!=-1 && cadena.indexOf("{")!=-1){
                    icon_tok.nextToken();
                    imagen=new ImageIcon(icon_tok.nextToken());
                }else{

                while(icon_tok.hasMoreTokens()){
                    String temp=icon_tok.nextToken();
                    if(temp.trim().indexOf("{")!=-1){
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        imagen=new ImageIcon(temp);
                    }else{
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        imagen=new ImageIcon(temp);
                        }

                }}
                System.out.println(imagen.toString());
        }
            if(cadena.indexOf("CONMUTATIVO")!=-1){
                //Por implementar.
            }
        }
    }
    /**
     * Devuelve la etiqueta del Verbo.
     * @return String etiqueta.
     */
    public String getEtiqueta(){
        return etiqueta;
    }
     /**
     * Devuelve la imagen del Verbo.
     * @return Image imagen del verbo.
     */
    public Image getImagen(){
        return imagen.getImage();
    }
}
